package com.mycompany.cxf.soap.endpoint;

import java.util.Map;

import org.apache.camel.Exchange;
import org.apache.camel.component.cxf.CxfBinding;
import org.apache.camel.component.cxf.DefaultCxfBinding;
import org.apache.cxf.binding.soap.SoapBindingConstants;

public class SoapHeaderCxfBinding extends DefaultCxfBinding {

    @Override
    protected void propagateHeadersFromCamelToCxf(Exchange camelExchange,
                                                  Map<String, Object> camelHeaders,
                                                  org.apache.cxf.message.Exchange cxfExchange,
                                                  Map<String, Object> cxfContext) {
        super.propagateHeadersFromCamelToCxf(camelExchange,camelHeaders,cxfExchange,cxfContext);
        cxfContext.put(SoapBindingConstants.SOAP_ACTION,camelHeaders.get(SoapBindingConstants.SOAP_ACTION));

    }

    public static void main(String[] args){
        final Class<CxfBinding> cxfBindingClass = CxfBinding.class;
        final Class<SoapHeaderCxfBinding> soapHeaderCxfBindingClass = SoapHeaderCxfBinding.class;
        System.out.println(cxfBindingClass.isAssignableFrom(soapHeaderCxfBindingClass));
    }
}
